
#ifndef _PLATFORM_H_
#define _PLATFORM_H_

enum { _clkfreq = 300'000'000 }; //Note: If you change this you must also change the NCO values to maintain 12 MHz output

// override baud rate for serial, requires use of "_setbaud(_BAUD);" in code
#ifndef _BAUD
#define _BAUD 230400
#endif

enum { heapsize = 16000 };  //override the default heapsize to give more, if needed

//Pick one of these board configs or add your own
#define P2Eval

//Pick one or none of these to say where files might come from
#define USE_SD
//#define USE_HOST

#define VGA_BASEPIN 16

//USB pin definitions
#define USB_BASE_PIN 24 //(basepin+3)  
#define USB_ENABLE_PIN -1  //not using a P2 pin 
#define USB_DM_PIN (USB_BASE_PIN+2) //+6 for upper or +2 for lower
#define USB_ERR_LED_PIN -1 //56       //Using P2 Eval board's P57 led for error display

//typedef boolean bool_t;
#define TRUE     (1)
#define FALSE    (0)

//Add in some needed includes here
#include "propeller2.h"
#include "stdio.h"
#include "stdlib.h"
#include "stdint.h"
#include "stdbool.h"
#include "string.h"


//some types not yet defined in FlexSpin, or needed to translate Arduino code
typedef char  byte;
typedef unsigned char uchar;
typedef char		bool_t;
typedef char		char8_t;
typedef unsigned char	uchar8_t;
typedef unsigned char prog_uchar8_t;
typedef signed char	schar8_t;
typedef float		float_t;

//RJA:  Seem to need this...
#define min(x,y)  ((x) > (y) ? (y) : (x))
#define max(x,y)  ((x) > (y) ? (x) : (y))



#endif /*_PLATFORM_H_*/
/* Nothing beyond this*/




