#include "ladders.h"
#include "Platform.h"

bool bSeriesOn;
bool bParallelOn;
bool bRungOn;



bool RunContact(ContactObject* pCO)
{

    pCO->bOn = bOn(pCO->bValue, pCO->bNegated);

    pCO->bSeriesOn = bSeriesOn;

    if (pCO->bOn == false)
        pCO->bSeriesOn = false;


    //if (pCO->bOn)
    if (pCO->bSeriesOn) //This seems to fix the TOF problem
        return true;
    else
        return false;

    
}

bool RunTon(TonObject* pTon)
{

    pTon->bSeriesOn = bSeriesOn;

    if (bSeriesOn)
    {
        pTon->count++; //increment count
        if (pTon->count >= pTon->oncycles)
            pTon->bOn = true;
        else
            pTon->bOn = false;
    }
    else
    {
        pTon->bOn = false;
        pTon->count = 0; //reset count
    }

    if (pTon->bOn == false)
        pTon->bSeriesOn = false;
    else
        pTon->bSeriesOn = true;

    if (pTon->bOn)
        return true;
    else
        return false;
}

bool RunToff(ToffObject* pToff)
{//Needs to return true for count after input goes false

    pToff->bSeriesOn = bSeriesOn;

    if (bSeriesOn == false)
    {

        if (pToff->count < pToff->offcycles)
        {
            pToff->count++; //increment count
            pToff->bOn = true;
        }
        else
            pToff->bOn = false;
    }
    else
    {
        pToff->bOn = true;
        pToff->count = 0; //reset count
    }

    if (pToff->bOn == false)
        pToff->bSeriesOn = false;

    if (pToff->bOn == true)
    {
        pToff->bSeriesOn = true;
        bSeriesOn = true;
    }


    if (pToff->bOn == true)
    {
        return true;
    }
    else
        return false;
}

void RunCoil(CoilObject* pCO)
{

    if (bSeriesOn==true)
    {
        pCO->bValue = true;
    }
    else
        pCO->bValue = false;

    if (pCO->bSetOnly)
    {
        if (pCO->bValue)
        {
            pCO->bOn = 1;
        }
    }
    else if (pCO->bResetOnly)
    {
        if (!pCO->bValue)
        {
            //io->newstate = 0;
            pCO->bOn = 0;
        }
    }
    else
    {
        pCO->bOn = bOn(pCO->bValue, pCO->bNegated);
    }
}



int RunParallel(int nRung, ProgramObject* p, int index)
{//Draw parallel objects
    int nStartRow = nRowRun;
    int nStartStep = nStepRun;
    int nEndStep = nStepRun + 1;
    index++;

    //bParallelOn = false;
    bool bso;

   // printf("Drawing Parallel at start step %d and end step %d\n", nStartStep, nEndStep);

    int WireStartStep;

    InstructionObject* pIO;
    do
    {
        pIO = p->p[index];
        WireStartStep = nEndStep;


        switch (pIO->type)
        {
        case CommentType:
            break;
        case ContactType:
            if (RunContact((ContactObject*)pIO) == true)
            {
                bParallelOn = true;
                //printf("Contact %s, Parallel on =%d\n", ((ContactObject*)pIO)->name ,bParallelOn);
            }
            break;
        case TonType:
            if (RunTon((TonObject*)pIO) == true)
            {
                bParallelOn = true;
                //printf("Parallel on =%d\n", bParallelOn);
            }
            break;
        case ToffType:
            if (SimulateToff((ToffObject*)pIO) == true)
            {
                bParallelOn = true;
                //printf("Parallel on =%d\n", bParallelOn);
            }
            break;
        case CoilType:
            RunCoil((CoilObject*)pIO);
            break;
        case EndType:
            //if (nStep == 0)
            //    DrawEnd();
            //nRow -= 3;
            break;
        case ParallelType:
            //printf("Drawing Parallel inside Parallel at step %d\n", nStep);
            index = RunParallel(nRung, p, index+1) - 1;
            break;
        case SeriesType:
           // nStep = nStartStep;
            //printf("Drawing series at step %d\n", nStep);
            bso = bSeriesOn; //save
            //bSeriesOn = true;
            index = RunSeries(nRung, p, index+1) -1;
            if (bSeriesOn == true)
                bParallelOn = true;
            nStepRun--;
            WireStartStep = nStepRun;
            if (nStepRun > nEndStep)
            {
                nEndStep = nStepRun;
                //if this is longer than previous, need to fill in with wire somehow?
            }
            nStepRun = nStartStep;
            bSeriesOn = bso;//restore
            break;
        default:
            break;
        }
        index++;




        //nRow+=3;

    } while (pIO->type != EndType);


    //nRow -= 3;





    nStepRun = nEndStep;


    
    nNextRungRowRun = nRowRun + 3;
    //printf("Parallel Setting nNextRungRow=%d\n", nNextRungRow);
    //nRow= nStartRow;

    //for (;;) {}
    return index;
}

int RunSeries(int nRung, ProgramObject* p, int index)
{//Draw series of objects

    //bSeriesOn = true;
    bool bpo;

    nNextRungRowRun = nRowRun + 3;
    InstructionObject* pIO;
    do
    {
        pIO = p->p[index];

        switch (pIO->type)
        {
        case CommentType:
            break;
        case ContactType:
            if (RunContact((ContactObject*)pIO) == false)
            {
                bSeriesOn = false;
            }
            break;
        case TonType:
            if (RunTon((TonObject*)pIO) == false)
            {
                bSeriesOn = false;
            }
            break;
        case ToffType:
            if (SimulateToff((ToffObject*)pIO) == true)
            {
                bSeriesOn = true;
            }
            break;
        case CoilType:
            RunCoil((CoilObject*)pIO);
            break;
        case EndType:
            break;
        case PlaceholderType:
            break;
        case ParallelType:
            bpo = bParallelOn;
            bParallelOn = false;
            index= RunParallel(nRung, p, index)-1;
            //printf("bParallelOn==%d, bSeriesOn=%d\n", bParallelOn, bSeriesOn);
            //if (bSeriesOn==true)
            //if (bParallelOn==false)
                bSeriesOn = bParallelOn;   
            //printf("bParallelOn==%d, bSeriesOn=%d\n", bParallelOn,bSeriesOn);
            bParallelOn = bpo;
            nStepRun--;
            break;
        case SeriesType:
            break;
        break;        default:
           // printf("Unrecognized type in series...\n");
            break;
        }
        index++;
        nStepRun++;
        //printf(" now nStep=%d\n", nStep);
    } while (pIO->type != EndType);

    //printf("done running a series, index=%d\n", index);
    return index;
}

int RunRung(int nRung, ProgramObject* p, int index)
{//Draw a rung of the ladder

    nStepRun = 0;
    bRungOn = true;
    bSeriesOn = true; //Maybe here is where it needs to start true?
    index = RunSeries(nRung, p, index);
    return index;
}


void SetInitialValue(ProgramObject* p)
{

}


//Need versions of these variables that won't get stomped on by other cogs
int nNextRungRowRun;
int nRowRun;
int nStepRun;

void RunProgram(ProgramObject* p)
{
    int nRung = 0;
    int index = 0;
    nRowRun = 1;
    nNextRungRowRun = nRowRun;

    //printf("\nLoop# %d: ", nLoop);

    //Update I/O pin outputs and new state based on current coil values
    index = 0;
    while (index < MaxInstructions)
    {//First go through looking for coils
        InstructionObject* in = p->p[index++];
        if (in == 0)
        {//End of program?
            break;
        }

        if (in->type == CoilType)
        {//found a coil
            CoilObject* pC = (CoilObject*)in;
            // printf("updating I/O pin for coil %s with dest %c\n", pC->name, pC->dest);
            if (pC->dest == 'Y')
            {//Output goes to I/O pin, so set it
                IO* io = (IO*)pC->pI;
                //printf("Setting I/O %s to %d\n", pC->name, pC->bOn);
                if (pC->bOn == true)
                {
                    _pinh(io->pin);
                    io->value = true;
                }
                else
                {
                    _pinl(io->pin);
                    io->value = false;
                }

            }
            else if (pC->dest == 'R')
            {//Output goes to Internal Relay, so set it
                Internal* intern = (Internal*)pC->pI;
                //printf("intern name=%s, value= %d\n", intern->name, intern->value);
                if (pC->bSetOnly)
                {
                    if (pC->bOn)
                    {
                        intern->value = 1;
                    }
                }
                else if (pC->bResetOnly)
                {
                    if (!pC->bOn)
                    {
                        intern->value = 0;
                    }
                }
                else
                    intern->value = pC->bOn;


                //printf("new intern value= %d\n", intern->value);
                //for (;;) {}
            }

        }
    }

    //Read I/O Inputs
    //Using Real I/O
    int nio = 0;
    while (nio < MaxIO)
    {//Update all IO states
        IO* io = IoFromFile.p[nio++];
        if (io == 0)
            break;
        io->value = _pinr(io->pin);

    }

    //Update contact state based on I/O pin input
    index = 0;
    while (index < MaxInstructions)
    {//Then, go through looking for contacts
        InstructionObject* in = p->p[index++];
        if (in == 0)
        {//End of program?
            break;
        }
        if (in->type == ContactType)
        {//found a contact, so update based on I/O pin state
            ContactObject* pC = (ContactObject*)in;
            // printf("updating I/O pin for contact %s with dest %c\n", pC->name, pC->dest);
            if (pC->source == 'X') //((pC->source == 'Y') || (pC->source == 'X'))
            {//This is input
                IO* io = (IO*)pC->pI;
                //io->value= _pinr(io->pin);
                pC->bValue = io->value;
                //printf("Setting I/O %s to %d, value=%d\n", pC->name, pC->bOn,pC->bValue);
                
            }
            else if (pC->source == 'Y')
            {
                IO* io = (IO*)pC->pI;
                //io->value = _pinr(io->pin);
                pC->bValue = io->value;
                //pC->bOn = bOn(pC->bValue, pC->bNegated);
            }
            else if (pC->source == 'R')
            {
                Internal* intern = (Internal*)pC->pI;
                pC->bValue = intern->value;
            }

        }
    }



    //Run the program
    index = 0;
    while (index < MaxInstructions)
    {//Do the program
        //nRow = nNextRungRow;

        InstructionObject* in = p->p[index++];
        if (in == 0)
        {//End of program?
            //printf("End of program..\n");

            break;
        }
        if (in->type != 0)
            //printf("Next instruction type = %d, index=%d\n", in->type, index);

            if (in->type == RungType)
            {
                //printf("Drawing Rung# %d\n", nRung + 1);

                //printf("Drawing next rung at row=%d\n", nRow);
                index = RunRung(++nRung, p, index);
                //nRow += 3;
            }


    }

    


    


}



