#include "ladders.h"
#include "Platform.h"




bool bOn(bool bValue, bool bNegated)
{//XOR
    //value negated color
    // 0      0      gray
    // 1      1      gray
    // 0      1      white
    // 1      0      white

    if (bValue == false)
        if (bNegated == false)
            return false;
        else
            return true;
    else
        if (bNegated == false)
            return true;
        else
            return false;
}

bool SimulateContact(ContactObject* pCO)
{
    pCO->bOn = bOn(pCO->bValue, pCO->bNegated);

    pCO->bSeriesOn = bSeriesOn;

    if (pCO->bOn == false)
        pCO->bSeriesOn = false;

    //if (pCO->bOn)
    if (pCO->bSeriesOn) //This seems to fix the TOF problem
        return true;
    else
        return false;
}


bool SimulateTon(TonObject* pTon)
{
    //pCO->bOn = bOn(pCO->bValue, pCO->bNegated);

    pTon->bSeriesOn = bSeriesOn;
    //printf("Start: pTon->bSeriesOn = %d, count=%d\n", pTon->bSeriesOn, pTon->count);

    if (bSeriesOn)
    {
        pTon->count++; //increment count
        if (pTon->count >= pTon->oncycles)
            pTon->bOn = true;
        else
            pTon->bOn = false;
    }
    else
    {
        pTon->bOn = false;
        pTon->count = 0; //reset count
    }

    if (pTon->bOn == false)
        pTon->bSeriesOn = false;
    else
        pTon->bSeriesOn = true;

    //printf("pTon->bSeriesOn = %d, count=%d\n", pTon->bSeriesOn, pTon->count);
    //_waitms(300);
    //for (;;) {}

    if (pTon->bOn)
        return true;
    else
        return false;
}

bool SimulateToff(ToffObject* pToff)
{//Needs to return true for count after input goes false

    pToff->bSeriesOn = bSeriesOn;
    //printf("Start: pToff->bSeriesOn = %d, count=%d\n", pToff->bSeriesOn, pToff->count);

    if (bSeriesOn==false)
    {
        
        if (pToff->count < pToff->offcycles)
        {
            pToff->count++; //increment count
            pToff->bOn = true;
        }
        else
            pToff->bOn = false;
    }
    else
    {
        pToff->bOn = true;
        pToff->count = 0; //reset count
    }

    if (pToff->bOn == false)
        pToff->bSeriesOn = false;

    if (pToff->bOn == true)
    {
        pToff->bSeriesOn = true;
        bSeriesOn = true;
    }
    //else
    //    pToff->bSeriesOn = false;

    //printf("pToff->bSeriesOn = %d, count=%d\n", pToff->bSeriesOn, pToff->count);
    //for (;;){}

    if (pToff->bOn==true)
    {
        //pToff->bSeriesOn = true;
        //bSeriesOn = true;
        return true;
    }
    else
        return false;
}

void SimulateCoil(CoilObject* pCO)
{//Simulate Coil

    if (bSeriesOn == true)
    {
        pCO->bValue = true;
    }
    else
        pCO->bValue = false;

    if (pCO->bSetOnly)
    {
        if (pCO->bValue)
        {
            pCO->bOn = 1;
        }
    }
    else if (pCO->bResetOnly)
    {
        if (!pCO->bValue)
        {
            //io->newstate = 0;
            pCO->bOn = 0;
        }
    }
    else
    {
        pCO->bOn = bOn(pCO->bValue, pCO->bNegated);
    }
}



int SimulateParallel(int nRung, ProgramObject* p, int index)
{//Draw parallel objects
    int nStartRow = nRowSim;
    int nStartStep = nStepSim;
    int nEndStep = nStepSim + 1;
    index++;

    //bParallelOn = false;
    
    bool bso; 
    bool bpo;

    //bool bOverideSeriesOn = false;

    //printf("Simulating Parallel at start step %d and end step %d\n", nStartStep, nEndStep);

    int WireStartStep;

    InstructionObject* pIO;
    do
    {
        pIO = p->p[index];
        WireStartStep = nEndStep;


        switch (pIO->type)
        {
        case CommentType:
            break;
        case ContactType:
            if (SimulateContact((ContactObject*)pIO) == true)
            {
                bParallelOn = true;
                
                //if (bParallelOn == false)
                //{
                //    for (;;) {}
                //}
            }
            //printf("Contact Parallel on =%d\n", bParallelOn);
            break;
        case TonType:
            if (SimulateTon((TonObject*)pIO) == true)
            {
                bParallelOn = true;

                //printf("Parallel on =%d\n", bParallelOn);
            }
            break;
        case ToffType:
            if (SimulateToff((ToffObject*)pIO) == true)
            {//This one can override series input
                bParallelOn = true;

               // bOverideSeriesOn = true;
                //printf("Parallel on =%d\n", bParallelOn);
            }
            break;
        case CoilType:
            SimulateCoil((CoilObject*)pIO);
            break;
        case EndType:

            break;
        case ParallelType:
            //printf("Simulating Parallel inside Parallel at step %d\n", nStepSim);
            bpo = bParallelOn;
            bParallelOn = false;
            index = SimulateParallel(nRung, p, index+1) - 1;
            if (bParallelOn == false)
                bSeriesOn = false;
            bParallelOn = bpo;
            break;
        case SeriesType:
            //printf("Simulating series at step %d\n", nStepSim);
            bso = bSeriesOn; //save
            //bSeriesOn = true;
            index = SimulateSeries(nRung, p, index+1) -1;
            if (bSeriesOn == true)
                bParallelOn = true;
            nStepSim--;
            WireStartStep = nStepSim;
            if (nStepSim > nEndStep)
            {
                nEndStep = nStepSim;
                //if this is longer than previous, need to fill in with wire somehow?
            }
            nStepSim = nStartStep;
            //printf("Series at step is %d\n", bSeriesOn);
            bSeriesOn = bso;//restore
            break;
        default:
            break;
        }
        index++;


    } while (pIO->type != EndType);


    nStepSim = nEndStep;

    //printf("Parallel is %d\n", bParallelOn);
    //if (bParallelOn==false)
   //     for (;;) {}
    
    nNextRungRowSim = nRowSim + 3;
    //printf("Parallel Setting nNextRungRowSim=%d\n", nNextRungRowSim);

    //if (bOverideSeriesOn == true)
    //{//Need to account for things like TOF that can turn series on...
    //    bSeriesOn = true;
    //}

    return index;
}

int SimulateSeries(int nRung, ProgramObject* p, int index)
{//Draw series of objects

    //bSeriesOn = true;
    bool bpo;
    //bool bso;
    

    nNextRungRowSim = nRowSim + 3;
    InstructionObject* pIO;
    do
    {
        pIO = p->p[index];

        switch (pIO->type)
        {
        case CommentType:
            break;
        case ContactType:
            if (SimulateContact((ContactObject*)pIO) == false)
            {
                bSeriesOn = false;
            }
            break;
        case TonType:
            if (SimulateTon((TonObject*)pIO) == false)
            {
                bSeriesOn = false;
            }
            else
                bSeriesOn = true;
            break;
        case ToffType:  
            if (SimulateToff((ToffObject*)pIO) == true)//false)
            {//This one can override series status
                bSeriesOn = true;// false;
                //printf("T");
            }
            //else
            //    bSeriesOn = false;
            break;
        case CoilType:
            SimulateCoil((CoilObject*)pIO);
            break;
        case EndType:
            break;
        case PlaceholderType:
            break;
        case ParallelType:
            bpo = bParallelOn;
            bParallelOn = false;
            //bso = bSeriesOn;
            index=SimulateParallel(nRung, p, index)-1;          
            //printf("bParallelOn==%d, bSeriesOn=%d\n", bParallelOn, bSeriesOn);
            //bSeriesOn = bso;

            //if (bSeriesOn == true)
                bSeriesOn = bParallelOn;
            
 
            //else
                
            bParallelOn = bpo;
            
            //printf("bParallelOn==%d, bSeriesOn=%d\n", bParallelOn,bSeriesOn);
            nStepSim--;
            break;
        case SeriesType:
            break;
        default:
           //printf("Unrecognized type in series...\n");
            break;
        }
        index++;
        nStepSim++;
        //printf(" now nStep=%d\n", nStepSim);
    } while (pIO->type != EndType);

    //printf("done simulating a series, index=%d\n", index);
    return index;
}

int SimulateRung(int nRung, ProgramObject* p, int index)
{//Draw a rung of the ladder

    nStepSim = 0;
    bRungOn = true;
    bSeriesOn = true; //Maybe here is where it needs to start true?
    index = SimulateSeries(nRung, p, index);
    return index;
}


//Need versions of these variables that won't get stomped on by other cogs
int nNextRungRowSim;
int nRowSim;
int nStepSim;


void SimulateProgram(ProgramObject* p)
{
    int nRung = 0;
    int index = 0;
    nNextRungRowSim = nRowSim;

    //printf("\nLoop# %d: ", nLoop);

        //Update I/O new state based on current coil values
    index = 0;
    while (index < MaxInstructions)
    {
        InstructionObject* in = p->p[index++];
        if (in == 0)
        {//End of program?
            break;
        }

        if (in->type == CoilType)
        {//found a coil
            CoilObject* pC = (CoilObject*)in;
            //printf("updating I/O pin for coil %s with dest %c\n", pC->name, pC->dest);
            if (pC->dest == 'Y')
            {//Output goes to I/O pin, so set it
                IO* io = (IO*)pC->pI;
                if (pC->bOn == true)
                {
                    //_pinh(io->pin);
                    io->value = true;
                }
                else
                {
                    //_pinl(io->pin);
                    io->value = false;
                }

            }
            else if (pC->dest == 'R')
            {//Output goes to Internal Relay, so set it
                Internal* intern = (Internal*)pC->pI;
                //printf("intern name=%s, value= %d\n", intern->name, intern->value);

                if (pC->bSetOnly)
                {
                    if (pC->bOn)
                    {
                        intern->value = 1;
                    }
                }
                else if (pC->bResetOnly)
                {
                    if (!pC->bOn)
                    {
                        intern->value = 0;
                    }
                }
                else
                    intern->value = pC->bOn;
            }

        }
    }

    //Update contact state based on I/O pin input
    index = 0;
    while (index < MaxInstructions)
    {//Then, go through looking for contacts
        InstructionObject* in = p->p[index++];
        if (in == 0)
        {//End of program?
            break;
        }
        if (in->type == ContactType)
        {//found a contact, so update based on I/O pin state
            ContactObject* pC = (ContactObject*)in;
            // printf("updating I/O pin for contact %s with dest %c\n", pC->name, pC->dest);
            if (pC->source == 'X') //((pC->source == 'Y') || (pC->source == 'X'))
            {//This is input
                IO* io = (IO*)pC->pI;
                pC->bValue = io->value;
            }
            else if (pC->source == 'Y')
            {
                IO* io = (IO*)pC->pI;
                pC->bValue = io->value;
            }
            else if (pC->source == 'R')
            {
                Internal* intern = (Internal*)pC->pI;
                pC->bValue = intern->value;
            }

        }
    }


    //Simulate Program
    index = 0;
    while (index<MaxInstructions)
    {//Do the Simulation

        InstructionObject* in = p->p[index++];
        if (in == 0)
        {//End of program?
            //printf("End of program..\n");

            break;
        }
        if (in->type!=0)
            //printf("Next instruction type = %d, index=%d\n", in->type, index);
        
        if (in->type == RungType)
        {
            //printf("Drawing Rung# %d\n", nRung + 1);
            
            //printf("Drawing next rung at row=%d\n", nRowSim);
            index = SimulateRung(++nRung, p, index);            
            
        }
                
        
    }

    


}



