/* This is auto-generated C code from LDmicro. Do not edit this file! Go
   back to the LDmicro ladder diagram source for changes in the ladder logic, and make
   any C additions either in ladder.h or in additional .c or .h files linked
   against this one. */

/* You must provide ladder.h; there you must provide:
   a typedef for SWORD and BOOLEAN_t, signed 16 bit and boolean types
   (probably typedef signed short SWORD; typedef unsigned char bool;)

   You must also provide implementations of all the I/O read/write
   either as inlines in the header file or in another source file. (The
   I/O functions are all declared extern.)

   See the generated source code (below) for function names. */

#include "ladder.h"
#include "Test4.h" // Copy this line into main project file where is function main().

/* Ux_xxx symbols correspond to user-defined names. There is such a symbol
   for every internal relay, variable, timer, and so on in the ladder
   program. Ix_xxx symbols are internally generated. */
/* Ix_xxx
   Ux_xxx
    ^
    b means bool type
    i means int type */
/* Define EXTERN_EVERYTHING in ladder.h if you want all symbols extern.
   This could be useful to implement `magic variables,' so that for
   example when you write to the ladder variable duty_cycle, your PLC
   runtime can look at the C variable U_duty_cycle and use that to set
   the PWM duty cycle on the micro. That way you can add support for
   peripherals that LDmicro doesn't know about. */

_STATIC_ BOOLEAN_t Ib_rung_top = 0;
_STATIC_ BOOLEAN_t Ib_parOut_0 = 0;
_STATIC_ BOOLEAN_t Ib_parThis_0 = 0;
#ifndef USE_MACRO
  // LDmicro provide this function.
  BOOLEAN_t Read_Ub_XStart(void) {
    return PINB & (1<<PINB22);
  }
#endif

#ifndef USE_MACRO
  // LDmicro provide these functions.
  BOOLEAN_t Read_Ub_YMotorOn(void) {
    return PORTB & (1<<PORTB25);
  }
  void Write_Ub_YMotorOn(BOOLEAN_t b) {
    if(b)
      PORTB |= 1<<PORTB25;
    else
      PORTB &= ~(1<<PORTB25);
  }
  void Write1_Ub_YMotorOn(void) {
      PORTB |= 1<<PORTB25;
  }
  void Write0_Ub_YMotorOn(void) {
      PORTB &= ~(1<<PORTB25);
  }
#endif

#ifndef USE_MACRO
  // LDmicro provide this function.
  BOOLEAN_t Read_Ub_XStop(void) {
    return PINB & (1<<PINB23);
  }
#endif

#ifndef USE_MACRO
  // LDmicro provide this function.
  BOOLEAN_t Read_Ub_XEnable(void) {
    return PINB & (1<<PINB24);
  }
#endif

_STATIC_ BOOLEAN_t Ub_RMBeenOn = 0;
#ifndef USE_MACRO
  // LDmicro provide these functions.
  BOOLEAN_t Read_Ub_YMBeenOnPin(void) {
    return PORTB & (1<<PORTB18);
  }
  void Write_Ub_YMBeenOnPin(BOOLEAN_t b) {
    if(b)
      PORTB |= 1<<PORTB18;
    else
      PORTB &= ~(1<<PORTB18);
  }
  void Write1_Ub_YMBeenOnPin(void) {
      PORTB |= 1<<PORTB18;
  }
  void Write0_Ub_YMBeenOnPin(void) {
      PORTB &= ~(1<<PORTB18);
  }
#endif


/* Call this function once per PLC cycle. You are responsible for calling
   it at the interval that you specified in the LDmicro MCU configuration when you
   generated this code. */
void PlcCycle(void) {
    // INIT TABLES
                        
    // ======= START RUNG 1 =======
    LabelRung1:;
    // Testing a very simple Start/Stop operation
    
    // ======= START RUNG 2 =======
    LabelRung2:;
    Write_Ib_rung_top(1);
    // start series [
    // start parallel [
    Write_Ib_parOut_0(0);
    Write_Ib_parThis_0(Read_Ib_rung_top());
    // ELEM_CONTACTS
    if(!Read_Ub_XStart()) {
        Write_Ib_parThis_0(0);
    }
    if(Read_Ib_parThis_0()) {
        Write_Ib_parOut_0(1);
    }
    Write_Ib_parThis_0(Read_Ib_rung_top());
    // ELEM_CONTACTS
    if(!Read_Ub_YMotorOn()) {
        Write_Ib_parThis_0(0);
    }
    if(Read_Ib_parThis_0()) {
        Write_Ib_parOut_0(1);
    }
    Write_Ib_rung_top(Read_Ib_parOut_0());
    // ] finish parallel
    // ELEM_CONTACTS
    if(Read_Ub_XStop()) {
        Write_Ib_rung_top(0);
    }
    // ELEM_CONTACTS
    if(!Read_Ub_XEnable()) {
        Write_Ib_rung_top(0);
    }
    // ELEM_COIL
    if(Read_Ib_rung_top()) {
        Write0_Ub_YMotorOn();
    } else {
        Write1_Ub_YMotorOn();
    }
    // ] finish series
    
    // ======= START RUNG 3 =======
    LabelRung3:;
    Write_Ib_rung_top(1);
    // start series [
    // ELEM_CONTACTS
    if(!Read_Ub_YMotorOn()) {
        Write_Ib_rung_top(0);
    }
    // ELEM_COIL
    if(Read_Ib_rung_top()) {
        Write_Ub_RMBeenOn(1);
    }
    // ] finish series
    
    // ======= START RUNG 4 =======
    LabelRung4:;
    Write_Ib_rung_top(1);
    // start series [
    // ELEM_CONTACTS
    if(!Read_Ub_RMBeenOn()) {
        Write_Ib_rung_top(0);
    }
    // ELEM_COIL
    Write_Ub_YMBeenOnPin(Read_Ib_rung_top());
    // ] finish series
    LabelRung5:;
    // Latest INT_OP here
}

void setupPlc(void) {
    // Set up I/O pins direction, and drive the outputs low to start.
    DDRA = 0x00;
    PORTA = 0x00;
    DDRB = 0x00;
    PORTB = 0x00;
    DDRC = 0x00;
    PORTC = 0x00;
    DDRD = 0x00;
    PORTD = 0x00;
    DDRE = 0x00;
    PORTE = 0x00;
    DDRF = 0x00;
    PORTF = 0x00;
    DDRG = 0x00;
    PORTG = 0x00;
    DDRH = 0x00;
    PORTH = 0x00;
    DDRJ = 0x00;
    PORTJ = 0x00;
    DDRK = 0x00;
    PORTK = 0x00;
    DDRL = 0x00;
    PORTL = 0x00;

    // Turn on the pull-ups on Port B.
    #ifdef CCS_PIC_C
        port_b_pullups(true);
    #elif defined(HI_TECH_C)
        nRBPU = 0;
    #endif

    #ifdef USE_WDT
      // Watchdog on
      #ifdef __CODEVISIONAVR__
        #ifndef WDTCR
            #define WDTCR WDTCSR
        #endif
        #asm("wdr")
        WDTCR |= (1<<WDE) | (1<<WDP2) | (1<<WDP1) | (1<<WDP0);
      #elif defined(__GNUC__)
        wdt_reset();
        wdt_enable(WDTO_2S);
      #elif defined(CCS_PIC_C)
        setup_wdt(WDT_2304MS);
      #elif defined(HI_TECH_C)
        //WDTCON=1;
      #else
        // Watchdog Init is required. // You must provide this.
      #endif
    #endif

    // Initialize PLC cycle timer here.
    // Configure Timer 1
    TCCR1A = 0x00; // WGM11=0, WGM10=0
    TCCR1B = (1<<WGM12) | 2; // WGM13=0, WGM12=1
    // `the high byte must be written before the low byte
    OCR1AH = (37499 >> 8) & 0xff;
    OCR1AL = 37499  & 0xff;
}

void mainPlc(void) { // Call mainPlc() function in main() of your project.
    // Put your setup code here, to run once, only if you no longer generate C code from LDmicro again.
    setupPlc();
    while(1) {
        // Test PLC cycle Timer 1 interval here.
        while((TIFR1 & (1<<OCF1A)) == 0);
        TIFR1 |= 1<<OCF1A;

        #ifdef USE_WDT
          WDT_restart(); // Watchdog reset
        #endif

        PlcCycle();
        // You can place your code here to run repeatedly, only if you no longer generate C code from LDmicro again.
        // ...
    }
}

// You can use main() as is.
int main(void) {
    // Put your setup code here, to run once, only if you no longer generate C code from LDmicro again.
    mainPlc();
    return 0;
}
